﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace machrAlgoritmy
{
    public partial class Form1 : Form
    {
        private Bitmap img;
        private Color[,] pixels;
        private String imgPath;

        public Form1()
        {
            InitializeComponent();
        }

        private void chooseButton_Click(object sender, EventArgs e)
        {
            
            if (chooseDialog.ShowDialog() == DialogResult.OK) // vybrání obrázku
            {
                try
                {
                    // nastavení formuláře podle velikosti obrázku
                    this.img = new Bitmap(chooseDialog.FileName); 
                    this.imgPath = chooseDialog.FileName;
                    previewBox.Height = this.img.Height;
                    previewBox.Width = this.img.Width * 2;
                    previewBox.Left = this.Width / 2 - this.img.Width / 2;
                    previewBox.Top = this.Height / 2 - this.img.Height;
                    previewBox.Image = this.img;
                    this.Size = new Size(previewBox.Width * 2, previewBox.Height + 300);
                }
                catch
                {
                    MessageBox.Show("Musíte vybrat obrázek!!!");
                }
            }
        }

        private void repairButton_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(this.imgPath)) // kontrola cesty k obrázku
            {
                MessageBox.Show("nevybral jste žádný obrázek");
            }
            else
            {
                for (int y = 0; y < this.img.Height; y++) // projizdi radky
                {
                    for (int x = 0; x < this.img.Width; x++) // projizdi sloupce
                    {
                        if (this.img.GetPixel(x, y).A == 0) // zjistí zda je vybraný pixel průhledny
                        {
                            try
                            {
                                // vybírání vhodné barvy pro neviditelný pixel
                                if (this.img.GetPixel(x + 1, y).A == 0)
                                {
                                        this.img.SetPixel(x, y, this.img.GetPixel(x - 1, y)); // vezme barvu pixelu nalevo
                                }
                                else
                                {
                                    this.img.SetPixel(x, y, this.img.GetPixel(x + 1, y)); // vezme barvu pixelu napravo
                                }
                            }
                            catch //tato výjmka se vyvolá, pokud je neviditelný pixel v pravém okraji 
                            {
                                this.img.SetPixel(x, y, this.img.GetPixel(x - 1, y)); // vezme barvu pixelu nalevo
                            }
                        }
                    }
                }


                try
                {
                    this.img.Save(this.imgPath + "_opraveny_ " + ".png"); // ukládání obrázku
                }
                catch (Exception ex)
                {
                    MessageBox.Show("při ukládání obrázku došlo k chybě: " + ex.ToString());
                }

                try
                {
                    this.previewBox.Image = new Bitmap(this.imgPath + "_opraveny_ " + ".png");
                }
                catch
                {
                    MessageBox.Show("při načítání náhledu nastala chyba");
                }
            }
        }

      
  

        
    }
}
